/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2009, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags. See the copyright.txt file in the
 * distribution for a full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package test;

import org.jboss.weld.environment.se.StartMain;
import org.testng.Assert;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

import javax.enterprise.context.spi.CreationalContext;
import javax.enterprise.inject.spi.BeanManager;
import javax.enterprise.inject.spi.Bean;

public class ConservatoryTest {
    
    private BeanManager beanManager;
    
    @BeforeClass
    public void Setup() {
        StartMain startMain = new StartMain(new String[0]);
        beanManager = startMain.go();
    }
    
    @Test
    public void test1() throws Exception {
        Bean<Sun> lightBean = (Bean<Sun>)beanManager.getBeans(Sun.class).iterator().next();
        CreationalContext<Sun> lightCc = beanManager.createCreationalContext(lightBean);
        Sun light = (Sun)beanManager.getReference(lightBean, Sun.class, lightCc);
        light.setState("bright");
        
        Bean<Conservatory> roomBean = (Bean<Conservatory>)beanManager.getBeans(Conservatory.class).iterator().next();
        CreationalContext<Conservatory> roomCc = beanManager.createCreationalContext(roomBean);
        Conservatory room = (Conservatory)beanManager.getReference(roomBean, Conservatory.class, roomCc);
        Assert.assertEquals(room.getLightState(), "bright");
    }
}
